package com.hzya.frame.plugin.lets.dingtalk.utils;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.aliyun.dingtalkoauth2_1_0.models.GetAccessTokenResponseBody;
import com.aliyun.dingtalkworkflow_1_0.models.*;
import com.dingtalk.api.response.OapiUserListidResponse;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.dingtalk.api.response.OapiV2UserGetbymobileResponse;
import com.hzya.frame.plugin.lets.dingtalk.vo.FileModuleVO;
import com.hzya.frame.plugin.lets.dingtalk.vo.SysFileVO;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Base64;
import java.util.List;
import java.util.UUID;

/**
 *  获取审批钉盘空间信息,spaceId:20852670637
 *  名称 ：                模板名称：                                       空间id：
 *  特殊业务处理（新）       PROC-AC33FC85-FB44-49FC-B926-1D966AE3BBD2       25354825296
 *  采购付款申请（新）       PROC-EC6B5BD2-DE3C-456E-9591-6F7B377E39E4       25354984089
 *  采购付款申请（店群专用）  PROC-285CCF2B-524F-4055-BE62-FC31F490C654       25354973072
 */
public class Test {
    public static void main(String[] args) throws Exception {
        String appKey="ding5qfifcktfqfjlem0";
        String appSecret="BVuLOy_K0F8f5np69VuBeKdb1zfwqhuPsAV49lNbYVbx5TnfSTHjwEcad9Vwzfq1";

        //获取token
        GetAccessTokenResponseBody tokenBody = DingTalkUtils.getTokenBody(appKey, appSecret);
        System.out.println(tokenBody.getAccessToken());

        //获取用户列表
//        OapiUserListidResponse userIdList = DingTalkUtils.getUserIdList(tokenBody.getAccessToken());
//        System.out.println(userIdList);

        //根据手机号查询用户详情,userid:6715600736721738
//        OapiV2UserGetbymobileResponse userByMobile = DingTalkUtils.getUserByMobile(tokenBody.getAccessToken(), "13783530043");
//        System.out.println(userByMobile.getResult().getUserid());

        //查询用户详情,unionId:xXpSQXdGCyYNcQXxrgezOwiEiE
//        OapiV2UserGetResponse userById = DingTalkUtils.getUserById(tokenBody.getAccessToken(), "6715600736721738");
//        System.out.println(userById.getBody());

        //获取审批钉盘空间信息,spaceId:20852670637
//        GetAttachmentSpaceResponse processDingPanSpaceInfo = DingTalkUtils.getProcessDingPanSpaceInfo(tokenBody.getAccessToken(), "6715600736721738");
//        System.out.println(processDingPanSpaceInfo.getBody().getResult().getSpaceId());

        //获取模板code，通过名称
//        GetProcessCodeByNameResponse processCode = DingTalkUtils.getProcessCode(tokenBody.getAccessToken(), "特殊业务处理（新）");
//        System.out.println(processCode.getBody().getResult().getProcessCode());//PROC-AC33FC85-FB44-49FC-B926-1D966AE3BBD2
//        GetProcessCodeByNameResponse processCode1 = DingTalkUtils.getProcessCode(tokenBody.getAccessToken(), "采购付款申请（新）");
//        System.out.println(processCode1.getBody().getResult().getProcessCode());//PROC-EC6B5BD2-DE3C-456E-9591-6F7B377E39E4
//        GetProcessCodeByNameResponse processCode2 = DingTalkUtils.getProcessCode(tokenBody.getAccessToken(), "采购付款申请（店群专用）");
//        System.out.println(processCode2.getBody().getResult().getProcessCode());//PROC-285CCF2B-524F-4055-BE62-FC31F490C654


        GetProcessInstanceResponse processInstanceDetails = DingTalkUtils.getProcessInstanceDetails(tokenBody.getAccessToken(), "TkERtV0BRW6GeqXcA0sMQg05751730701542");
        System.out.println(processInstanceDetails.getBody().getResult().getFormComponentValues());
        List<GetProcessInstanceResponseBody.GetProcessInstanceResponseBodyResultFormComponentValues> formComponentValues =
                processInstanceDetails.getBody().getResult().getFormComponentValues();
        //获取附件的表单
        List<FileModuleVO> fileModuleVOList=new ArrayList<>();
        for (GetProcessInstanceResponseBody.GetProcessInstanceResponseBodyResultFormComponentValues formComponentValue : formComponentValues) {
            if("DDAttachment".equals(formComponentValue.getComponentType())){
                String value = formComponentValue.getValue();
                System.out.println(value);
                fileModuleVOList = JSONUtil.toList(value, FileModuleVO.class);
            }
        }
        List<SysFileVO> sysFileVOList=new ArrayList<>();
        for (FileModuleVO fileModuleVO : fileModuleVOList) {
//            String targetPath = "D:\\ding-file\\download\\"+fileModuleVO.getFileName()+fileModuleVO.getFileId()+"."+fileModuleVO.getFileType();
            String targetPath = "D:\\ding-file\\download\\"+"TkERtV0BRW6GeqXcA0sMQg05751730701542\\";
            SysFileVO sysFileVO = new SysFileVO();
            GrantProcessInstanceForDownloadFileResponse grantProcessInstanceForDownloadFileResponse = DingTalkUtils.downloadProcessFile(tokenBody.getAccessToken(), "TkERtV0BRW6GeqXcA0sMQg05751730701542", fileModuleVO.getFileId());
            System.out.println(grantProcessInstanceForDownloadFileResponse.getBody().getResult().getDownloadUri());
            String uri = grantProcessInstanceForDownloadFileResponse.getBody().getResult().getDownloadUri();
            URL url = new URL(uri);
            HttpURLConnection httpConn = (HttpURLConnection) url.openConnection();
            int responseCode = httpConn.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {
                InputStream inputStream = httpConn.getInputStream();
                FileOutputStream outputStream = new FileOutputStream(targetPath);
                byte[] buffer = new byte[4096];
                int bytesRead;

                while ((bytesRead = inputStream.read(buffer)) != -1) {
                    outputStream.write(buffer, 0, bytesRead);
                }
                //转为base64编码
                // 读取文件内容到字节数组
                byte[] fileContent = Files.readAllBytes(Paths.get(targetPath));
                // 将字节数组转换为 Base64 编码的字符串
                String encodedString = Base64.getEncoder().encodeToString(fileContent);

                sysFileVO.setFileName(fileModuleVO.getFileName());
                sysFileVO.setType(fileModuleVO.getFileType());
                sysFileVO.setBaseCode(encodedString);
                System.out.println(sysFileVO);
                sysFileVOList.add(sysFileVO);

                //关闭资源
                outputStream.close();
                inputStream.close();
                httpConn.disconnect();
            } else {
                throw new IOException("无法下载文件，HTTP响应码: " + responseCode);
            }
        }


    }

//    /**
//     * 生成回调key
//     * @param args
//     */
//        public static void main(String[] args) {
//            String key = Base64.encodeBase64String(UUID.randomUUID().toString().replaceAll("-","").getBytes());
//            System.out.println(key);
//
//        }
}

