package com.hzya.frame.plugin.lets.plugin.dingtalk;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.locks.ReentrantLock;

/**
 * 为避免回调超时，每天定时检查所有未审批完成的审批实例。
 */
public class DingCallBackPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(DingCallBackPluginInitializer.class);

    private static final ReentrantLock LOCK = new ReentrantLock(true);

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "transfer.TransferInPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "丽知：钉钉审批实例自动检查";
    }

    @Override
    public String getPluginLabel() {
        return "丽知：钉钉审批实例自动检查";
    }

    @Override
    public String getPluginType() {
        return "1";
    }

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) throws Exception {
        return null;
    }


}
