package com.hzya.frame.report.lets.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.excel.EasyExcel;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.page.PageAttribute;
import com.hzya.frame.report.lets.dao.ITocofsReturngoodsDetailedDao;
import com.hzya.frame.report.lets.dao.ITocofsSaleoutDao;
import com.hzya.frame.report.lets.dao.ITocofsSaleoutDetailedDao;
import com.hzya.frame.report.lets.dto.TobofsReturnGoodsDetailedDto;
import com.hzya.frame.report.lets.dto.TobofsSaleoutDetailedDto;
import com.hzya.frame.report.lets.dto.TocofsReturnGoodsDetailedDto;
import com.hzya.frame.report.lets.dto.TocofsSaleoutDetailedDto;
import com.hzya.frame.report.lets.entity.TocofsReturngoodsDetailedEntity;
import com.hzya.frame.report.lets.entity.TocofsReturngoodsEntity;
import com.hzya.frame.report.lets.entity.TocofsSaleoutDetailedEntity;
import com.hzya.frame.report.lets.entity.TocofsSaleoutEntity;
import com.hzya.frame.report.lets.service.ITocofsSaleoutService;
import com.hzya.frame.uuid.UUIDLong;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.File;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * root(TocofsSaleout)表服务实现类
 *
 * @author makejava
 * @since 2024-08-01 17:01:32
 */
@Service(value = "tocofsSaleoutServiceImplReport")
public class TocofsSaleoutServiceImpl extends BaseService<TocofsSaleoutEntity, String> implements ITocofsSaleoutService {

    private ITocofsSaleoutDao tocofsSaleoutDao;

    @Autowired
    private ITocofsSaleoutDetailedDao iTocofsSaleoutDetailedDao;

    @Autowired
    private ITocofsReturngoodsDetailedDao iTocofsReturngoodsDetailedDao;

    @Autowired
    public void setTocofsSaleoutDao(ITocofsSaleoutDao dao) {
        this.tocofsSaleoutDao = dao;
        this.dao = dao;
    }

    @Override
    public JsonResultEntity queryToCSalesReport(JSONObject jsonObject) throws Exception {
        Assert.notNull(jsonObject, "jsonObject不能为空！");
        JSONObject jsonStr = getstrObj("jsonStr", jsonObject);

        //提供两种模式：查询模式 query、导出模式 excel
        String qType = jsonStr.getString("qType");
        //表头编码
        String headCode = jsonStr.getString("headCode");
        //业务类型：TOB、TOC
        String businessType = jsonStr.getString("businessType");
        Assert.notNull(businessType, "businessType不能为空!");
        //出库日期范围
        String businessDate_start = jsonStr.getString("businessDate_start");
        String businessDate_end = jsonStr.getString("businessDate_end");
        if (businessDate_start != null) {
            businessDate_start += " 00:00:00";
        }
        if (businessDate_end != null) {
            businessDate_end += " 23:59:59";
        }
        //交易成功时间范围
        String successfulTradeDate_start = jsonStr.getString("successfulTradeDate_start");
        if (successfulTradeDate_start != null) {
            successfulTradeDate_start += " 00:00:00";
        }
        String successfulTradeDate_end = jsonStr.getString("successfulTradeDate_end");
        if (successfulTradeDate_end != null) {
            successfulTradeDate_end += " 23:59:59";
        }
        //推送时间
        String newPushDate = jsonStr.getString("newPushDate");
        String def5 = jsonStr.getString("def5");
        String def1 = jsonStr.getString("def1");
        String def3 = jsonStr.getString("def3");

        //推送状态
        String newState = jsonStr.getString("newstate");//推送状态：TOB、TOC库存同步成功
        String newState4 = jsonStr.getString("newState4");
        String newstate2 = jsonStr.getString("newstate2");
        String newstate3 = jsonStr.getString("newstate3");
        //下游系统单号、下游系统主键
        String newsystemnumber = jsonStr.getString("newsystemnumber");
        String newsystemprimary = jsonStr.getString("newsystemprimary");
        String newSystemNumber4 = jsonStr.getString("newsystemnumber4");
        String newSystemPrimary4 = jsonStr.getString("newsystemprimary4");
        String newsystemnumber2 = jsonStr.getString("newsystemnumber2");
        String newsystemprimary2 = jsonStr.getString("newsystemprimary2");
        String newsystemnumber3 = jsonStr.getString("newsystemnumber3");
        String newsystemprimary3 = jsonStr.getString("newsystemprimary3");

        TocofsSaleoutDetailedEntity tocofsSaleoutDetailedEntity = new TocofsSaleoutDetailedEntity();
        tocofsSaleoutDetailedEntity.setBusinesstype(businessType);

        tocofsSaleoutDetailedEntity.setBusinessdate_start(businessDate_start);
        tocofsSaleoutDetailedEntity.setBusinessdate_end(businessDate_end);
        tocofsSaleoutDetailedEntity.setSuccessfultradedate_start(successfulTradeDate_start);
        tocofsSaleoutDetailedEntity.setSuccessfultradedate_end(successfulTradeDate_end);

        tocofsSaleoutDetailedEntity.setNewpushdate(newPushDate);
        tocofsSaleoutDetailedEntity.setDef5(def5);
        tocofsSaleoutDetailedEntity.setDef1(def1);
        tocofsSaleoutDetailedEntity.setDef3(def3);

        tocofsSaleoutDetailedEntity.setNewstate(newState);
        tocofsSaleoutDetailedEntity.setNewstate4(newState4);
        tocofsSaleoutDetailedEntity.setNewstate2(newstate2);
        tocofsSaleoutDetailedEntity.setNewstate3(newstate3);

        tocofsSaleoutDetailedEntity.setNewsystemnumber(newsystemnumber);
        tocofsSaleoutDetailedEntity.setNewsystemprimary(newsystemprimary);
        tocofsSaleoutDetailedEntity.setNewsystemnumber4(newSystemNumber4);
        tocofsSaleoutDetailedEntity.setNewsystemprimary4(newSystemPrimary4);
        tocofsSaleoutDetailedEntity.setNewsystemnumber2(newsystemnumber2);
        tocofsSaleoutDetailedEntity.setNewsystemprimary2(newsystemprimary2);
        tocofsSaleoutDetailedEntity.setNewsystemnumber3(newsystemnumber3);
        tocofsSaleoutDetailedEntity.setNewsystemprimary3(newsystemprimary3);

        tocofsSaleoutDetailedEntity.setHeadCode(headCode);

        //默认查询模式：开发分页，获取分页参数
        if (qType == null || "".equals(qType.trim()) || "query".equals(qType)) {
            String pageNum = jsonStr.getString("pageNum");
            String pageSize = jsonStr.getString("pageSize");
            Assert.notNull(pageNum, "pageNum不能为空");
            Assert.notNull(pageSize, "pageSize不能为空");
            tocofsSaleoutDetailedEntity.setPageNum(Integer.valueOf(pageNum));
            tocofsSaleoutDetailedEntity.setPageSize(Integer.valueOf(pageSize));
            PageHelper.startPage(tocofsSaleoutDetailedEntity.getPageNum(), tocofsSaleoutDetailedEntity.getPageSize());
            List<TocofsSaleoutDetailedEntity> tocofsSaleoutDetailedEntityPageAttribute = iTocofsSaleoutDetailedDao.query(tocofsSaleoutDetailedEntity);
            PageInfo pageInfo = new PageInfo(tocofsSaleoutDetailedEntityPageAttribute);
            return BaseResult.getSuccessMessageEntity("查询成功", pageInfo);
        } else if ("excel".equals(qType)) {
            //Excel导出模式，加载全部的数据，交给上层方法最终转换为Excel文件提供给前端下载
            if (businessType.equals("TOC_ORDER")) {
                //TOC销售
                List<TocofsSaleoutDetailedDto> tocofsSaleoutDetailedDtos = new ArrayList<>();
                try {
                    tocofsSaleoutDetailedDtos = iTocofsSaleoutDetailedDao.queryEntityListBaseToc(tocofsSaleoutDetailedEntity);
                } catch (Exception e) {
                    logger.error("queryEntityListBaseToc方法抛出异常", e);
                }
                return BaseResult.getSuccessMessageEntity("查询成功", tocofsSaleoutDetailedDtos);
            } else if (businessType.equals("TOB_ORDER")) {
                //TOB销售
                List<TobofsSaleoutDetailedDto> tobofsSaleoutDetailedDtos = null;
                try {
                    tobofsSaleoutDetailedDtos = iTocofsSaleoutDetailedDao.queryEntityListBaseTob(tocofsSaleoutDetailedEntity);
                } catch (Exception e) {
                    logger.error("queryEntityListBaseTob方法抛出异常", e);
                }
                return BaseResult.getSuccessMessageEntity("查询成功", tobofsSaleoutDetailedDtos);
            } else {
                return BaseResult.getFailureMessageEntity("查询失败，无法确定TOB、TOC！请选择：TOC_ORDER、或者TOB_ORDER！");
            }
        } else {
            return BaseResult.getFailureMessageEntity("查询失败，无法确定查询模式！请选择：查询模式 query、导出模式 excel！");
        }
    }

    @Value("${report.templatesurl}")
    private String reportTemplatesurl;

    @Override
    public JsonResultEntity exportToCSalesReportExcel(JSONObject jsonObject) throws Exception {
        Assert.notNull(jsonObject, "jsonObject不能为空");

        JSONObject jsonStr = getstrObj("jsonStr", jsonObject);
        Assert.notNull(jsonStr, "jsonStr对象不能为空！");
        jsonStr.put("qType", "excel");

        //覆盖一遍
        jsonObject.put("jsonStr", jsonStr);

        String businessType = jsonStr.getString("businessType");
        Assert.notNull(businessType, "businessType不能为空!");

        JsonResultEntity jsonResultEntity = queryToCSalesReport(jsonObject);
        if (jsonResultEntity != null && jsonResultEntity.getAttribute() != null) {
            InputStream templateFileName = this.getClass().getClassLoader().getResourceAsStream(reportTemplatesurl);
            String[] excelFile = createExcelFile();

            if (businessType.equals("TOC_ORDER")) {
                List<TocofsSaleoutDetailedDto> tocofsSaleoutDetailedEntityList = (List<TocofsSaleoutDetailedDto>) jsonResultEntity.getAttribute();
                EasyExcel.write(excelFile[0], TocofsSaleoutDetailedDto.class).withTemplate(templateFileName).sheet().doWrite(tocofsSaleoutDetailedEntityList);
                return BaseResult.getSuccessMessageEntity(excelFile[1]);
            } else if (businessType.equals("TOB_ORDER")) {
                List<TobofsSaleoutDetailedDto> tobofsSaleoutDetailedEntityList = (List<TobofsSaleoutDetailedDto>) jsonResultEntity.getAttribute();
                EasyExcel.write(excelFile[0], TobofsSaleoutDetailedDto.class).withTemplate(templateFileName).sheet().doWrite(tobofsSaleoutDetailedEntityList);
                return BaseResult.getSuccessMessageEntity(excelFile[1]);
            } else {
                return BaseResult.getFailureMessageEntity("查询失败，无法确定TOB、TOC！请选择：TOC_ORDER、或者TOB_ORDER！");
            }
        }
        return BaseResult.getFailureMessageEntity("生成TOC、TOB销售业务对应的Excel文件失败！");
    }

    @Value("${report.tempFile}")
    private String reportTempFile;

    /**
     * 2024年7月19日 11:11:55 生成新Excel文件的路径
     *
     * @author liuyang
     */
    private String[] createExcelFile() {
//        String projectPath = System.getProperty("user.dir");
        String projectPath = reportTempFile;

        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(projectPath);
        String path = stringBuffer.toString();

        Long randomLong = UUIDLong.longUUID();
        String newName = randomLong + ".xlsx";

        //不存在则创建
        File dir = new File(path + File.separator + "excelfile");
        if (!dir.exists()) {
            dir.mkdirs();
        }

        String filePath = path + File.separator + "excelfile" + File.separator + newName;
        String[] strings = new String[2];
        strings[0] = filePath;
        strings[1] = newName;
        return strings;
    }

    @Override
    public JsonResultEntity queryToCReturnReport(JSONObject jsonObject) throws Exception {
//        long startTime = System.currentTimeMillis();
        Assert.notNull(jsonObject, "jsonObject不能为空");
        JSONObject jsonStr = getstrObj("jsonStr", jsonObject);

        //提供两种模式：查询模式 query、导出模式 excel
        String qType = jsonStr.getString("qType");

        //业务类型：TOB、TOC
        String businessType = jsonStr.getString("businesstype");
        Assert.notNull(businessType, "businessType不能为空!");

        //表头编码
        String headCode = jsonStr.getString("headCode");

        //入库日期范围
        String businessDate_start = jsonStr.getString("businessdate_start");
        String businessDate_end = jsonStr.getString("businessdate_end");
        if (businessDate_start != null) {
            businessDate_start += " 00:00:00";
        }
        if (businessDate_end != null) {
            businessDate_end += " 23:59:59";
        }

        //退款完成时间范围
        String refundedAt_start = jsonStr.getString("refundedat_start");
        if (refundedAt_start != null) {
            refundedAt_start += " 00:00:00";
        }
        String refundedAt_end = jsonStr.getString("refundedat_end");
        if (refundedAt_end != null) {
            refundedAt_end += " 23:59:59";
        }

        //推送时间
        String newPushDate = jsonStr.getString("newpushdate");
        String newPushDate2 = jsonStr.getString("newpushdate2");
        String newPushDate3 = jsonStr.getString("newpushdate3");
        String newPushDate4 = jsonStr.getString("newpushdate4");

        //推送状态
        String newState = jsonStr.getString("newstate");
        String newState2 = jsonStr.getString("newstate2");
        String newState3 = jsonStr.getString("newstate3");
        String newState4 = jsonStr.getString("newstate4");

        //下游系统单号、下游系统主键
        String newSystemNumber = jsonStr.getString("newsystemnumber");
        String newSystemPrimary = jsonStr.getString("newsystemprimary");
        String newSystemNumber2 = jsonStr.getString("newsystemnumber2");
        String newSystemPrimary2 = jsonStr.getString("newsystemprimary2");
        String newSystemNumber3 = jsonStr.getString("newsystemnumber3");
        String newSystemPrimary3 = jsonStr.getString("newsystemprimary3");
        String newSystemNumber4 = jsonStr.getString("newsystemnumber4");
        String newSystemPrimary4 = jsonStr.getString("newsystemprimary4");

        TocofsReturngoodsDetailedEntity tocofsSaleoutDetailedEntity = new TocofsReturngoodsDetailedEntity();
        tocofsSaleoutDetailedEntity.setBusinesstype(businessType);

        tocofsSaleoutDetailedEntity.setBusinessdate_start(businessDate_start);
        tocofsSaleoutDetailedEntity.setBusinessdate_end(businessDate_end);
        tocofsSaleoutDetailedEntity.setRefundedAt_start(refundedAt_start);
        tocofsSaleoutDetailedEntity.setRefundedAt_end(refundedAt_end);

        tocofsSaleoutDetailedEntity.setNewpushdate(newPushDate);
        tocofsSaleoutDetailedEntity.setNewpushdate2(newPushDate2);
        tocofsSaleoutDetailedEntity.setNewpushdate3(newPushDate3);
        tocofsSaleoutDetailedEntity.setNewpushdate4(newPushDate4);

        tocofsSaleoutDetailedEntity.setNewstate(newState);
        tocofsSaleoutDetailedEntity.setNewstate2(newState2);
        tocofsSaleoutDetailedEntity.setNewstate3(newState3);
        tocofsSaleoutDetailedEntity.setNewstate4(newState4);

        tocofsSaleoutDetailedEntity.setNewsystemnumber(newSystemNumber);
        tocofsSaleoutDetailedEntity.setNewsystemprimary(newSystemPrimary);
        tocofsSaleoutDetailedEntity.setNewsystemnumber2(newSystemNumber2);
        tocofsSaleoutDetailedEntity.setNewsystemprimary2(newSystemPrimary2);
        tocofsSaleoutDetailedEntity.setNewsystemnumber3(newSystemNumber3);
        tocofsSaleoutDetailedEntity.setNewsystemprimary3(newSystemPrimary3);
        tocofsSaleoutDetailedEntity.setNewsystemnumber4(newSystemNumber4);
        tocofsSaleoutDetailedEntity.setNewsystemprimary4(newSystemPrimary4);

        tocofsSaleoutDetailedEntity.setHeadCode(headCode);

        //开启分页
        if (qType == null || "".equals(qType.trim()) || "query".equals(qType.trim())) {
            String pageNum = jsonStr.getString("pageNum");
            String pageSize = jsonStr.getString("pageSize");
            Assert.notNull(pageNum, "pageNum不能为空");
            Assert.notNull(pageSize, "pageSize不能为空");
            tocofsSaleoutDetailedEntity.setPageNum(Integer.valueOf(pageNum));
            tocofsSaleoutDetailedEntity.setPageSize(Integer.valueOf(pageSize));
            PageHelper.startPage(tocofsSaleoutDetailedEntity.getPageNum(), tocofsSaleoutDetailedEntity.getPageSize());
            List<TocofsReturngoodsDetailedEntity> tocofsSaleoutDetailedEntityPageAttribute = iTocofsReturngoodsDetailedDao.query(tocofsSaleoutDetailedEntity);
            PageInfo pageInfo = new PageInfo(tocofsSaleoutDetailedEntityPageAttribute);
            return BaseResult.getSuccessMessageEntity("查询成功", pageInfo);
        } else if ("excel".equals(qType)) {
            if (businessType.equals("TOC_RETURN")) {
                //TOC退货
                List<TocofsReturnGoodsDetailedDto> tocofsReturnGoodsDetailedDtos = new ArrayList<>();
                try {
                    tocofsReturnGoodsDetailedDtos = iTocofsReturngoodsDetailedDao.queryEntityListBaseToc(tocofsSaleoutDetailedEntity);
                } catch (Exception e) {
                    logger.error("queryEntityListBaseToc方法抛出异常", e);
                }
                return BaseResult.getSuccessMessageEntity("查询成功", tocofsReturnGoodsDetailedDtos);
            } else if (businessType.equals("TOB_RETURN")) {
                //TOB退货
                List<TobofsReturnGoodsDetailedDto> tobofsReturnGoodsDetailedDtos = new ArrayList<>();
                try {
                    tobofsReturnGoodsDetailedDtos = iTocofsReturngoodsDetailedDao.queryEntityListBaseTob(tocofsSaleoutDetailedEntity);
                } catch (Exception e) {
                    logger.error("queryEntityListBaseTob方法抛出异常", e);
                }
                return BaseResult.getSuccessMessageEntity("查询成功", tobofsReturnGoodsDetailedDtos);
            } else {
                return BaseResult.getFailureMessageEntity("查询失败，无法确定TOB、TOC！请选择：TOC_ORDER、或者TOB_ORDER！");
            }
        } else {
            return BaseResult.getFailureMessageEntity("查询失败，无法确定查询模式！请选择：查询模式 query、导出模式 excel！");
        }
    }

    @Override
    public JsonResultEntity exportToCReturnReportExcel(JSONObject jsonObject) throws Exception {
        Assert.notNull(jsonObject, "jsonObject不能为空");

        JSONObject jsonStr = getstrObj("jsonStr", jsonObject);
        Assert.notNull(jsonStr, "jsonStr对象不能为空！");
        jsonStr.put("qType", "excel");

        //覆盖一遍
        jsonObject.put("jsonStr", jsonStr);

        String businessType = jsonStr.getString("businesstype");
        Assert.notNull(businessType, "businesstype不能为空!");

        JsonResultEntity jsonResultEntity = queryToCReturnReport(jsonObject);
        if (jsonResultEntity != null && jsonResultEntity.getAttribute() != null) {
            InputStream templateFileName = this.getClass().getClassLoader().getResourceAsStream(reportTemplatesurl);
            String[] excelFile = createExcelFile();

            if (businessType.equals("TOC_RETURN")) {
                List<TocofsReturnGoodsDetailedDto> tocofsSaleoutDetailedEntityList = (List<TocofsReturnGoodsDetailedDto>) jsonResultEntity.getAttribute();
                EasyExcel.write(excelFile[0], TocofsReturnGoodsDetailedDto.class).withTemplate(templateFileName).sheet().doWrite(tocofsSaleoutDetailedEntityList);
                return BaseResult.getSuccessMessageEntity(excelFile[1]);
            } else if (businessType.equals("TOB_RETURN")) {
                List<TobofsReturnGoodsDetailedDto> tobofsSaleoutDetailedEntityList = (List<TobofsReturnGoodsDetailedDto>) jsonResultEntity.getAttribute();
                EasyExcel.write(excelFile[0], TobofsReturnGoodsDetailedDto.class).withTemplate(templateFileName).sheet().doWrite(tobofsSaleoutDetailedEntityList);
                return BaseResult.getSuccessMessageEntity(excelFile[1]);
            } else {
                return BaseResult.getFailureMessageEntity("查询失败，无法确定TOB、TOC！请选择：TOC_ORDER、或者TOB_ORDER！");
            }
        }
        return BaseResult.getFailureMessageEntity("生成TOC、TOB销售业务对应的Excel文件失败！");
    }
}
